//\\\ ///\\\ ///\\\ ///\\\ ///\\\ ///\\\//\\\ ///\\\ ///\\\ ///\\\ ///\\\ ///\\\//\\\ ///\\\ ///\\\ ///\\\ ///\\\ 
/*
  Name: Morption 1.0
  Copyright: 2008
  Original Author: Amaury Graillat
  Contribution:
  Date: 04/04/08
  Description: It's a simple server HTTP.
  Environment : J2ME Wirless Toolkit 2.2 + Notepad++ ;-)
  License: CC-by-nc-sa
  File:  Morpion.java
  
    This source is distributed with CC-by-nc-sa license. 

*/
//------------------------------------------------------------------------------------------------------------------------------------------------
// TODO: X Execo quand la grille est pleine.
// TODO: X Choisir quijoue en 1er.
// TODO: O Prise en charges des touche directionnels.
// NOTE: /!\ Attention si on fais plusieurs parties d'affiles penser  turn!
// http://www.phpcs.com/codes/JEU-MORPION-INTELLIGENT-HUMAIN-VERSUS-PHP_34404.aspx
//------------------------------------------------------------------------------------------------------------------------------------------------

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import java.io.*;
import java.util.*;

//Class principale:
public class Morpion extends MIDlet
{
	private Display _display; // Display est indispensable  l'affichage
	private Moteur  _moteur;  // objet qui va grer le droulement du jeu

	public Morpion()a&
	{	
		//On initialise le moteur graphique:
		_moteur = new Moteur();
		
		//Initialise l'affichage
		_display = Display.getDisplay(this);
	}

	
	public void startApp()
	{
		_moteur.info = "BEGIN";
		
		_display.setCurrent(_moteur);
		
		Random random = new Random();
		int who = Math.abs( random.nextInt() % 512 );
		
		if(who >= 256) _moteur.computer(_moteur.P_RED, _moteur.P_BLUE);
		
		while(_moteur.info != "STOP")
		{
			//Obfuscated code which sleep 100 ms ----------|
			try{Thread.sleep(     100    );
			}catch(InterruptedException e){
			e.printStackTrace   (   )  ;  }
			
			//System.out.println(_moteur.info);
			
			if(_moteur.info == "STOP") break;
				
			_moteur.refresh();
		}
		
		//Obfuscated code which sleep 3000 ms --------|
		try{Thread.sleep(    3000    );
		}catch(InterruptedException e){
		e.printStackTrace   (   )  ;  }
		
		destroyApp(true);
		notifyDestroyed();
	}

	public void pauseApp()
	{
	}

	public void destroyApp(boolean unconditional)
	{
		_moteur.info = "STOP";
	}
}

//Moteur du jeu:
class Moteur extends Canvas
{
	//::Constantes::
	public final int BLANK     = 1;
	public final int P_RED     = 10;
	public final int P_BLUE    = 100;
	public final int P_GREEN   = 1000;
	
	public final int SEL_BLANK = 2;
	public final int SEL_RED   = 11;
	public final int SEL_BLUE  = 101;
	public final int SEL_GREEN = 1001;
	
	//Var
	private int _height; // hauteur totale de l'cran
	private int _width;  // largeur totale de l'cran
	private int _max;
	private int selPosX = 0;
	private int selPosY = 0;
	private int turn;   //turn number : nombres de tours:
	
	public String info;
	public int level = 2;

	//Grid (map)
	// /*
	public int grid[][] = {{SEL_BLANK, BLANK, BLANK},
	                       {    BLANK, BLANK, BLANK},
						   {    BLANK, BLANK, BLANK}};
	//*/
	
	//Random numbers:
	Random random = new Random();
	
	//Computeur grid:
	public int gridTemp[][] = new int[3][3];
	
	//Return the winner team:
	public int IsWin(boolean compGrid)
	{	
		//Is the grid full:
		boolean full=true;
		for(int x = 0; x<3; x++)
			for(int y = 0; y<3; y++)
				if(GetTeam(x,y, false)==BLANK) full=false;
		
		//horizontally:
		if(		GetTeam(0,0, compGrid) != BLANK
				&& GetTeam(0,0, compGrid) == GetTeam(0,1, compGrid)
				&& GetTeam(0,0, compGrid) == GetTeam(0,2, compGrid))
					return GetTeam(0,2, compGrid);
				
		else if(GetTeam(1,0, compGrid) != BLANK
				&& GetTeam(1,0, compGrid) == GetTeam(1,1, compGrid)
				&& GetTeam(1,0, compGrid) == GetTeam(1,2, compGrid))
					return GetTeam(1,2, compGrid);
					
		else if(GetTeam(2,0, compGrid) != BLANK
				&& GetTeam(2,0, compGrid) == GetTeam(2,1, compGrid)
				&& GetTeam(2,0, compGrid) == GetTeam(2,2, compGrid))
					return GetTeam(2,2, compGrid);
 
		//vertically:
		else if(GetTeam(0,0, compGrid) != BLANK
				&& GetTeam(0,0, compGrid) == GetTeam(1,0, compGrid)
				&& GetTeam(0,0, compGrid) == GetTeam(2,0, compGrid))
					return GetTeam(0,0, compGrid);
					
		else if(GetTeam(0,1, compGrid) != BLANK
				&& GetTeam(0,1, compGrid) == GetTeam(1,1, compGrid)
				&& GetTeam(0,1, compGrid) == GetTeam(2,1, compGrid))
					return GetTeam(0,1, compGrid);
		
		else if(GetTeam(0,2, compGrid) != BLANK
				&& GetTeam(0,2, compGrid) == GetTeam(1,2, compGrid)
				&& GetTeam(0,2, compGrid) == GetTeam(2,2, compGrid))
					return GetTeam(0,2, compGrid);
		
		//Diagonal:
		else if(GetTeam(0,0, compGrid) != BLANK
				&& GetTeam(0,0, compGrid) == GetTeam(1,1, compGrid)
				&& GetTeam(0,0, compGrid) == GetTeam(2,2, compGrid))
					return GetTeam(0,0, compGrid);
					
		else if(GetTeam(0,2, compGrid) != BLANK
				&& GetTeam(0,2, compGrid) == GetTeam(1,1, compGrid)
				&& GetTeam(0,2, compGrid) == GetTeam(2,0, compGrid))
					return GetTeam(0,2, compGrid);
		
		else if(full) return -2;
		
		//Nowhere:
		return -1;
	}
	
	public void refresh()
	{	
		//Winner?
		int stat = IsWin(false);
		
		if(     stat == P_RED ) info = "RED WIN";
		else if(stat == P_BLUE) info = "BLUE WIN";
		else if(stat == -2) info = "EXECO";
	
		repaint();
	}
	
	//Return the square value:
	public int GetValue(int x, int y)
	{
		//All on fais mme pas de vrif, on envoie sec!! :p
		return grid[x][y];
	}
	
	// Return the team color
	public int GetTeam(int x, int y, boolean compGrid)
	{
		if(compGrid)
		{			
			if(     gridTemp[x][y] == P_RED   || gridTemp[x][y] == SEL_RED)   return P_RED;
			else if(gridTemp[x][y] == P_BLUE  || gridTemp[x][y] == SEL_BLUE)  return P_BLUE;
			else if(gridTemp[x][y] == P_GREEN || gridTemp[x][y] == SEL_GREEN) return P_GREEN;
			else return BLANK;
		}
		else
		{
			if(     grid[x][y] == P_RED   | grid[x][y] == SEL_RED)    return P_RED;
			else if(grid[x][y] == P_BLUE  || grid[x][y] == SEL_BLUE)  return P_BLUE;
			else if(grid[x][y] == P_GREEN || grid[x][y] == SEL_GREEN) return P_GREEN;
			else return BLANK;
		}
	}
	
	public void SetValue(int x, int y, int val)
	{
		//Et ben ca s'arrenge pas!!
		grid[x][y] = val;		
		return;
	}
	
	//Dessine les cases:
	protected void paint(Graphics g)
	{
		if(info == "STOP") return;
		
		//Dimention max of the square:
		if(_width >= _height) _max = _height;
		else _max = _width;

		// dessin du fond
		g.setColor(0, 0, 0);
		g.fillRect(0,0,_width,_height);
		
		//Draw squares:
		for(int x = 0; x<3; x++)
		{
			for(int y = 0; y<3; y++)
			{
				int posX   = (x * _max /3);
				int posY   = (y * _max /3);
				int width  = (_max /3);
				int height = (_max /3);
				
				//Blank
				if(GetValue(x,y) == BLANK)
				{					  
					g.setColor(196,196,196); //Gris
					g.fillRect(posX, posY, width, height);
				}
				//Player red:
				else if(GetValue(x,y) == P_RED)
				{ 
					g.setColor(255,0,0); //Red
					g.fillRect(posX, posY, width, height);
				}
				//Player blue:
				else if(GetValue(x,y) == P_BLUE)
				{
					g.setColor(0,0,255); //Blue
					g.fillRect(posX, posY, width, height);
				}
				//Player green
				else if(GetValue(x,y) == P_GREEN)
				{
					g.setColor(55,249,6); //Vert
					g.fillRect(posX, posY, width, height);
				}
				//Selected blue:
				else if(GetValue(x,y) == SEL_BLUE)
				{
					g.setColor(0,0,128); //Blue
					g.fillRect(posX, posY, width, height);
				}
				//Selected red
				else if(GetValue(x,y) == SEL_RED)
				{
					g.setColor(128,0,0); //Red
					g.fillRect(posX, posY, width, height);
				}
				//Selected blank
				else if(GetValue(x,y) == SEL_BLANK)
				{
					g.setColor(70,70,70); //Gris
					g.fillRect(posX, posY, width, height);
				}
				//Selected green
				else if(GetValue(x,y) == SEL_GREEN)
				{
					g.setColor(43,192,5); //Vert
					g.fillRect(posX, posY, width, height);
				}
				else
				{
					System.out.println("An error occured in Moteur : paint : Draw squares");
				}
			}
		}		
		
		//Draw the grid:
		g.setColor(0,0,0);
		g.drawRect(0,0, 1 * _max /3,   1*_max/3);
		g.drawRect(0,0, 2 * _max /3,   1*_max/3);
		g.drawRect(0,0, 3 * _max /3-1, 1*_max/3);
		g.drawRect(0,0, 1 * _max /3,   2*_max/3);
		g.drawRect(0,0, 2 * _max /3,   2*_max/3);
		g.drawRect(0,0, 3 * _max /3-1, 2*_max/3);
		g.drawRect(0,0, 1 * _max /3,   3*_max/3);
		g.drawRect(0,0, 2 * _max /3,   3*_max/3);
		g.drawRect(0,0, 3 * _max /3-1, 3*_max/3);
		
		//Display messages:
		if(info == "BEGIN")
		{
			g.setColor(255, 255, 255);
			g.drawString("Use this key : ",10,10, 0);
			g.drawString("        2"         ,10,26, 0);
			g.drawString(" 4<         >6"     ,10,42, 0);
			g.drawString("        8"         ,10,58, 0);
			g.drawString(" 1: Level"         ,10,74, 0);
		}
		else if(info == "LEVEL HIGH")
		{
			g.setColor(255, 255, 255);
			g.drawString("Level : High",10,10, 0);
		}
		else if(info == "LEVEL MEDIUM")
		{
			g.setColor(255, 255, 255);
			g.drawString("Level : Medium",10,10, 0);
		}
		else if(info == "LEVEL LOW")
		{
			g.setColor(255, 255, 255);
			g.drawString("Level : Low",10,10, 0);
		}
		else if(info == "EXECO")
		{
			g.setColor(255, 255, 255);
			g.drawString("Execo...",10,10, 0);
			info = "STOP";
		}
		else if(info == "BLUE WIN")
		{
			g.setColor(255, 255, 255);
			g.drawString("Congratulation!",10,10, 0);
			info = "STOP";
		}
		else if(info == "RED WIN")
		{
			g.setColor(255, 255, 255);
			g.drawString("Yesssss! Sorry... but...",10,10, 0);
			g.drawString("          ...I beat you!",10,23, 0);
			info = "STOP";
		}
		
	}
	
	//AI:
	public int computer(int COMPUTER, int HUMAN)
	{
		System.out.println("--- Tour de l'ordianteur ---");
		
		//Algo Mini-Max
		int minimax[][] = new int[3][3];
		
		int Xto=-1;
		int Yto=-1;
						   	
		//Copies the main grid in gridTemp:
		for(int yy = 0; yy<3; yy++)
			for(int xx = 0; xx<3; xx++)	
				gridTemp[xx][yy] = GetTeam(xx,yy,false);
		
		//TODO: Recherche d'une position adverse qui force 2 positions gagnantes:
		if(Xto==-1 && Yto==-1 && level >= 1)
		{
			System.out.println("Recherche d'une position adverse qui force 2 positions gagnantes");
			for(int x = 0; x<3; x++)
			{
				for(int y = 0; y<3; y++)
				{
					if (gridTemp[x][y] == BLANK)
					{
						gridTemp[x][y] = COMPUTER;
						
						int WinCount = 0;
						
						for(int xx = 0; xx<3; xx++)
						{
							for(int yy = 0; yy<3; yy++)
							{
								if(gridTemp[x][y] == BLANK)
								{
									gridTemp[x][y] = COMPUTER;
									if(IsWin(true) == COMPUTER) WinCount++;
									gridTemp[xx][yy] = BLANK;
								}
							}
						}
						
						if(WinCount>=2)
						{
							Xto = x;
							Yto = y;
							
							//Break the loop:
							x  = 4;
							x  = 4;
							
							System.out.println("Trouve");
						}
						
						gridTemp[x][y] = BLANK;
					}
				}
			}
		}

		
		//Attack:
		//If the computer can wins now: Si on peut gagner  ce tour:
		if(Xto==-1 && Yto==-1  && level >= 0)
		{
			for(int x = 0; x<3; x++)
			{
				for(int y = 0; y<3; y++)
				{
					if(gridTemp[x][y] == BLANK)
					{
						gridTemp[x][y] = COMPUTER;
						if(IsWin(true) == COMPUTER)
						{
							System.out.println("je peux gagner!!");
							Xto = x;
							Yto = y;
						}
						gridTemp[x][y] = BLANK;
					}
				}
			}
		}
		
		//TODO: Recherche d'une position qui dispense 2 positions gagnantes:
		if(Xto==-1 && Yto==-1 && level >= 2)
		{
			System.out.println("Recherche d'une position qui dispense 2 positions gagnantes");
			for(int x = 0; x<3; x++)
			{
				for(int y = 0; y<3; y++)
				{
					if (gridTemp[x][y] == BLANK)
					{
						gridTemp[x][y] = COMPUTER;
						
						int WinCount = 0;
						
						for(int xx = 0; xx<3; xx++)
						{
							for(int yy = 0; yy<3; yy++)
							{
								if(gridTemp[x][y] == BLANK)
								{
									gridTemp[x][y] = COMPUTER;
									if(IsWin(true) == COMPUTER) WinCount++;
									gridTemp[xx][yy] = BLANK;
								}
							}
						}
						
						if(WinCount>=2)
						{
							System.out.println("Trouve");
							Xto = x;
							Yto = y;
							
							//Break the loop:
							x  = 4;
							x  = 4;
						}
						
						gridTemp[x][y] = BLANK;
					}
				}
			}
		}
		
		//Attack:
		//prevents the humain win : Empche le gus de gagner...
		if(Xto==-1 && Yto==-1 && level >= 0)
		{
			for(int x = 0; x<3; x++)
			{
				for(int y = 0; y<3; y++)
				{
					if(gridTemp[x][y] == BLANK)
					{
						gridTemp[x][y] = HUMAN;
						if(IsWin(true) == HUMAN)
						{
							System.out.println("Empche l'adversaire de gagner...");
							Xto = x;
							Yto = y;
						}
						gridTemp[x][y] = BLANK;
					}
				}
			}
		}
		
		//in the centre:
		if(Xto==-1 && Yto==-1 && level >= 0)
		{
			if(gridTemp[1][1] == BLANK)
			{	
				System.out.println("au centre parce qu'il est libre...");
				Xto = 1;
				Yto = 1;
			}
		}
		
		//In 2nd turn: everywhere without in cardinals points:  Joue de partout sauf aux points cardinaux au 2me tour:
		if(Xto==-1 && Yto==-1 && turn==2  && level >= 2)
		{
			System.out.println("2me tour : partout sauf au points cardinaux...");
			while(Yto == -1 && Xto == -1)
			{
				switch(Math.abs( random.nextInt() % 3))
				{
					case 0: if(gridTemp[0][0] == BLANK) { Yto = 0; Xto = 0;	} break;
					case 1: if(gridTemp[2][2] == BLANK) { Yto = 2; Xto = 2; } break;
					case 2: if(gridTemp[0][2] == BLANK) { Yto = 0; Xto = 2; } break;
					case 3: if(gridTemp[2][0] == BLANK) { Yto = 2; Xto = 0; } break;
				}
			}
		}
		
		//Everywhere... : on joue n'importe o!!
		if(Xto==-1 && Yto==-1)
		{	
			int Xtmp = Math.abs( random.nextInt() % 2);
			int Ytmp = Math.abs( random.nextInt() % 2);
			
			System.out.println("n'importe ou!!");
			while(Yto == -1 && Xto == -1)
			{
				System.out.println("|||||||");
				for(int y = Xtmp; y<3; y++)
					for(int x = Ytmp; x<3; x++)
					{
						if(gridTemp[x][y] == BLANK) {Xto = x; Yto = y;}
						System.out.println("x=" + String.valueOf(x) + " y=" + String.valueOf(y));
					}
						
				Xtmp = 0;
				Ytmp = 0;
			}
		}
		
		//Plays!!
		if(Xto!=-1 && Yto!=-1)	SetValue(Xto,Yto,COMPUTER);
		else System.out.println("ERREUR! AUCUNE CASE N'A ETE CHOISITE!");
		
		//System.out.println(String.valueOf(GetValue(0,0)) + " " + String.valueOf(GetValue(0,1)) + " " + String.valueOf(GetValue(0,2)));
		//System.out.println(String.valueOf(GetValue(1,0)) + " " + String.valueOf(GetValue(1,1)) + " " + String.valueOf(GetValue(1,2)));
		//System.out.println(String.valueOf(GetValue(2,0)) + " " + String.valueOf(GetValue(2,1)) + " " + String.valueOf(GetValue(2,2)));
		
		return 0;
	}

	protected void keyPressed(int keyCode)
	{
		//On rtablis la valeur d'origine:
		if     (GetValue(selPosX, selPosY) == SEL_BLANK ) SetValue(selPosX, selPosY, BLANK  );
		else if(GetValue(selPosX, selPosY) == SEL_RED   ) SetValue(selPosX, selPosY, P_RED  );
		else if(GetValue(selPosX, selPosY) == SEL_BLUE  ) SetValue(selPosX, selPosY, P_BLUE );
		else if(GetValue(selPosX, selPosY) == SEL_GREEN ) SetValue(selPosX, selPosY, P_GREEN);
		
		//Level:
		if(keyCode == Canvas.KEY_NUM1 || keyCode == Canvas.UP)
		{
			//if(info == "BEGIN") info = "START";
			info = "START";
			level++;
			if(level == 3) level = 0;
			
			if     (level == 0) info = "LEVEL LOW";
			else if(level == 1) info = "LEVEL MEDIUM";
			else if(level == 2) info = "LEVEL HIGH";
		}
		//Up
		else if(keyCode == Canvas.KEY_NUM2 || keyCode == Canvas.UP)
		{
			//if(info == "BEGIN" || info=="LEVEL LOW" || info=="LEVEL MEDIUM" || info=="LEVEL HIGH") info = "START";
			info = "START";
			if(selPosY > 0) selPosY--;
		}
		//down
		else if(keyCode == Canvas.KEY_NUM8 || keyCode == Canvas.DOWN)
		{
			//if(info == "BEGIN" || info=="LEVEL LOW" || info=="LEVEL MEDIUM" || info=="LEVEL HIGH") info = "START";
			info = "START";
			if(selPosY < 2) selPosY++;
		}
		//Right
		else if(keyCode == Canvas.KEY_NUM6 || keyCode == Canvas.RIGHT)
		{
			//if(info == "BEGIN" || info=="LEVEL LOW" || info=="LEVEL MEDIUM" || info=="LEVEL HIGH") info = "START";
			info = "START";
			if(selPosX < 2) selPosX++;
		}
		//Left
		else if(keyCode == Canvas.KEY_NUM4 || keyCode == Canvas.LEFT)
		{
			//if(info == "BEGIN" || info=="LEVEL LOW" || info=="LEVEL MEDIUM" || info=="LEVEL HIGH") info = "START";
			info = "START";
			if(selPosX > 0) selPosX--;
		}
		//Ok
		else if(keyCode == Canvas.KEY_NUM5)
		{
			if(info == "BEGIN") info = "START";
			if(GetValue(selPosX, selPosY) == BLANK)
			{
				turn++; //et un tour de plus!!
				SetValue(selPosX, selPosY, SEL_BLUE);
				refresh();
				if(info != "BLUE WIN" && info != "EXECO") computer(P_RED, P_BLUE);
			}
			return;
		}
	
		if     (GetValue(selPosX, selPosY) == BLANK  ) SetValue(selPosX, selPosY, SEL_BLANK);
		else if(GetValue(selPosX, selPosY) == P_RED  ) SetValue(selPosX, selPosY, SEL_RED  );
		else if(GetValue(selPosX, selPosY) == P_BLUE ) SetValue(selPosX, selPosY, SEL_BLUE );
		else if(GetValue(selPosX, selPosY) == P_GREEN) SetValue(selPosX, selPosY, SEL_GREEN);
		
		return;
	}
	
	//Constructeur:
	public Moteur()
	{
		random.setSeed(System.currentTimeMillis());
		
		turn = 0; //turn number : nombres de tours:
		_height = getHeight(); // hauteur totale de l'cran
	    _width  = getWidth(); // largeur totale de l'cran

		repaint();
	}

};
//\\\ ///\\\ ///\\\ ///\\\ ///\\\ ///\\\//\\\ ///\\\ ///\\\ ///\\\ ///\\\ ///\\\//\\\ ///\\\ ///\\\ ///\\\ ///\\\  